<template>
  <abeuni-form
    class="assigned-list"
    title="Lista de Registros QR"
    subtitle="Lista dos registros QR locais"
  >
    <vue-fuse
      :keys="config.search_keys"
      :list="assigned"
      :placeholder="`Search from ${assigned.length} entries`"
      @fuseResultsUpdated="search"
    />
    <div class="list">
      <div
        class="item"
        v-for="{ data, metadata } in list.slice(0, 20)"
        :key="data.id"
        :title="dateFromISO(data.timestamp)"
      >
        <span class="item-name">{{ data.person.fullname }}</span>
        <span class="item-code"
          >{{ data.code }} |
          {{ timeRender.counter && relativeFromISO(data.timestamp) }}</span
        >
        <span class="item-status"
          ><span
            class="dot"
            :style="`background-color: ${colorFromMetadata(metadata)}`"
            tool
        /></span>
      </div>
    </div>
  </abeuni-form>
</template>

<script>
import { DateTime } from 'luxon'
import { mapGetters } from 'vuex'
import AbeuniForm from './forms/AbeuniForm'
import { setInterval, clearInterval } from 'timers'
import _ from 'lodash'

export default {
  components: {
    AbeuniForm
  },
  data () {
    return {
      timeRender: {
        interval: null,
        counter: 1
      },
      list: [],
      config: {
        search_keys: ['data.person.fullname', 'data.person.document.value']
      }
    }
  },
  computed: {
    assigned () {
      return this.assignedList.map(assignment => {
        const obj = _.cloneDeep(assignment)

        obj.data.person = this.registered.filter(
          entry => entry.data.id === assignment.data.ref
        )[0].data

        return obj
      })
    },
    ...mapGetters({
      registered: 'registeredList',
      assignedList: 'assignedList'
    })
  },
  mounted () {
    this.timeRender.interval = setInterval(
      () => this.timeRender.counter++,
      1000
    )
  },
  destroyed () {
    clearInterval(this.timeRender.interval)
  },
  methods: {
    search (results) {
      this.list = results
    },
    colorFromMetadata (metadata) {
      if (metadata.origin !== 'local') return 'blue'

      if (metadata.uploaded) return 'green'
      else return 'red'
    },
    relativeFromISO (iso) {
      const datetime = DateTime.fromISO(iso)
      return datetime.toRelative()
    },
    dateFromISO (iso) {
      const datetime = DateTime.fromISO(iso)
      return datetime.toHTTP()
    }
  }
}
</script>

<style lang="scss" scoped>
.assigned-list {
  .list {
    .item {
      display: grid;
      grid-template:
        "name name stat"
        "code code stat";

      grid-template-columns: auto auto 20px;

      padding: 1.5em;

      cursor: pointer;
      border-radius: 5px;
    }

    .item:hover {
      background: #eee;
    }

    .item > .item-name {
      grid-area: name;

      font: 1.3em sans-serif;

      max-width: 15em;

      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
    }

    .item > .item-code {
      grid-area: code;

      margin-top: 5px;
    }
    .item > .item-status {
      grid-area: stat;

      .dot {
        height: 20px;
        width: 20px;
        border-radius: 50%;
        display: inline-block;

        margin: auto;
      }

      display: flex;
    }

    display: flex;
    flex-direction: column;

    margin-top: 2em;
  }
}
</style>
